import React from 'react';
import { IOptionProps, IString } from '../../@types';
import { ILabelProps } from '../label/Label';
import AutocompleteListContianer from './AutocompleteListContianer';
import AutocompleteItem from './AutocompleteItem';
import AutocompleteList from './AutocompleteList';
import AutocompleteGroupList from './AutocompleteGroupList';
import AutocompleteNoItem from './AutocompleteNoItem';
export interface IAutocompleteProps<T> {
    /**
     * Defines the appearance or layout of container around Autocomplete & Label
     */
    containerClass?: string;
    /**
     * Defines the auto complete search input disabled
     */
    disabled?: boolean;
    /**
     * Defines the appearance or layout of the Label component
     */
    labelProps?: ILabelProps;
    /**
     * Defines the labelText for form label
     */
    labelText?: string;
    /**
     * Defines the callback hander when option selected
     */
    onChange?: (props: any) => void;
    /**
     * Defines the callback for search input text
     */
    onInputValueChange?: (searchText: IString) => void;
    /**
     * Defines the callback for internal state changes
     */
    onStateChange?: (changes: any) => void;
    /**
     * Defines the list items details in Autocomplete
     */
    options: T[];
    /**
     * Defines the input placeholder
     */
    placeholder?: string;
    /**
     * Defines the add area when auto complete item not found
     */
    renderAddArea?: (props: any) => React.ReactNode;
    /**
     * Defiens the list items rendering whether normal or grouped list
     */
    renderList?: (props: any) => React.ReactNode;
    /**
     * Defines the selected option from the list
     */
    selected?: T;
    /**
     * Defines avatar visibility in each option
     */
    showAvatar?: boolean;
    /**
     * Defines the icon for toggle button on the rightside
     */
    toggleButtonIcon?: string;
}
declare const Autocomplete: {
    <T extends IOptionProps>({ containerClass, disabled, labelProps, labelText, onChange, onInputValueChange, onStateChange, options, placeholder, renderAddArea, renderList, selected, showAvatar, toggleButtonIcon, ...other }: IAutocompleteProps<T>): JSX.Element;
    List: typeof AutocompleteList;
    GroupList: typeof AutocompleteGroupList;
    ListContainer: typeof AutocompleteListContianer;
    Item: typeof AutocompleteItem;
    NoItem: typeof AutocompleteNoItem;
};
export default Autocomplete;
//# sourceMappingURL=Autocomplete.d.ts.map